library angular2.src.core.compiler.ng_element;

import "package:angular2/src/dom/dom_adapter.dart" show DOM;
import "package:angular2/src/facade/lang.dart" show normalizeBlank;
import "../compiler/view.dart" as viewModule;
import "package:angular2/src/render/dom/direct_dom_renderer.dart"
    show
        DirectDomViewRef; /**
 * Allows direct access to the underlying DOM element.
 *
 * Attention: NgElement will be replaced by a different concept
 * for accessing an element in a way that is compatible with the render layer.
 *
 * @exportedAs angular2/core
 */

class NgElement {
  viewModule.AppView _view;
  num _boundElementIndex;
  NgElement(view, boundElementIndex) {
    this._view = view;
    this._boundElementIndex = boundElementIndex;
  } // TODO(tbosch): Here we expose the real DOM element.
  // We need a more general way to read/write to the DOM element
  // via a proper abstraction in the render layer
  get domElement {
    DirectDomViewRef domViewRef = this._view.render;
    return domViewRef.delegate.boundElements[this._boundElementIndex];
  }
  String getAttribute(String name) {
    return normalizeBlank(DOM.getAttribute(this.domElement, name));
  }
}
