library angular2.test.router.router_spec;

import "package:angular2/test_lib.dart"
    show
        AsyncTestCompleter,
        describe,
        proxy,
        it,
        iit,
        ddescribe,
        expect,
        inject,
        beforeEach,
        SpyObject;
import "package:angular2/src/facade/lang.dart" show IMPLEMENTS;
import "package:angular2/src/facade/async.dart" show Future, PromiseWrapper;
import "package:angular2/src/router/router.dart" show RootRouter, Viewport;
import "package:angular2/src/router/pipeline.dart" show Pipeline;
import "package:angular2/src/router/router_outlet.dart" show RouterOutlet;

main() {
  describe("Router", () {
    var router;
    beforeEach(() {
      router = new RootRouter(new Pipeline());
    });
    it("should navigate after being configured", inject([
      AsyncTestCompleter
    ], (async) {
      var outlet = makeDummyRef();
      router
          .registerOutlet(outlet)
          .then((_) => router.navigate("/a"))
          .then((_) {
        expect(outlet.spy("activate")).not.toHaveBeenCalled();
        return router.config("/a", {"component": "A"});
      }).then((_) {
        expect(outlet.spy("activate")).toHaveBeenCalled();
        async.done();
      });
    }));
  });
}
@proxy
@IMPLEMENTS(RouterOutlet)
class DummyOutletRef extends SpyObject implements RouterOutlet {
  noSuchMethod(m) {
    return super.noSuchMethod(m);
  }
}
makeDummyRef() {
  var ref = new DummyOutletRef();
  ref.spy("activate").andCallFake((_) => PromiseWrapper.resolve(true));
  ref.spy("canActivate").andCallFake((_) => PromiseWrapper.resolve(true));
  ref.spy("canDeactivate").andCallFake((_) => PromiseWrapper.resolve(true));
  ref.spy("deactivate").andCallFake((_) => PromiseWrapper.resolve(true));
  return ref;
}
